<template>
  <div>
    <div class="d-flex justify-content-between align-items-center py-2">
      <h1>User List</h1>
      <input placeholder="Search..." class="form-control" @input="search" v-model="searchQuery" />
      <div>
        <router-link class="btn btn-primary" to="/users/new">Create</router-link>
      </div>
    </div>

    <ul class="list-group">
      <li v-for="user in users" :key="user._id" class="list-group-item">
        <router-link :to="`/users/${user._id}`">{{user.username}}</router-link>
        <span
          v-if="user._id === $store.getters['auth/user']._id"
          class="badge badge-pill badge-primary ml-1"
        >That's you</span>
      </li>
    </ul>
    <app-feedback v-if="status">{{status}}</app-feedback>
  </div>
</template>

<script>
import api from "@/services/api.service";

export default {
  data() {
    return {
      status: "",
      searchQuery: "",
      users: []
    };
  },
  methods: {
    search() {
      api
        .get(`/users?find=${this.searchQuery}`)
        .then(users => (this.users = users.data));
    }
  },
  async created() {
    try {
      const r = await api.get("/users");
      this.users = r.data;
    } catch (error) {
      this.status = error.response.data;
    }
  }
};
</script>

<style scoped>
h1 {
  margin-bottom: 0px !important;
}
input {
  max-width: 40rem;
  margin: 0rem 0.5rem;
}
</style>